package com.infoepoch.pms.agent.platform.model.domain.irepository;

import com.infoepoch.pms.agent.platform.model.domain.SystemSettings;

import java.util.List;
import java.util.Optional;

/**
 * @author jiangyz
 * @date 2026/4/17 15:37
 * 系统全局配置键值对仓储接口
 */
public interface ISystemSettingsRepository {
    /**
     * 新增
     * @param: [entity]
     */
    boolean insert(SystemSettings entity);

    /**
     * 更新
     * @param: [entity]
     */
    boolean update(SystemSettings entity);

    /**
     * 批量新增
     * @param: [entitys]
     */
    int[] batchInsert(List<SystemSettings> entitys);

    /**
     * 批量更新
     * @param: [entitys]
     */
    int[] batchUpdate(List<SystemSettings> entitys);

    /**
     * 删除
     * @param: [id]
     */
    boolean delete(String id);

    // region select

    /**
     * 根据Id查询
     * @param: [id]
     */
    SystemSettings selectById(String id);

    /**
     * 根据查询条件查询单个对象
     * @param: [criteria]
     */
    SystemSettings selectOneByCriteria(SystemSettingsCriteria criteria);

    /**
     * 根据查询条件查询对象集合
     * @param: [criteria]
     */
    List<SystemSettings> selectByCriteria(SystemSettingsCriteria criteria);

    /**
     * 根据查询条件分页查询对象结合
     * @param: [criteria, pageNum, pageSize]
     */
    List<SystemSettings> selectCriteriaByPage(SystemSettingsCriteria criteria, int pageNum, int pageSize);

    /**
     * 根据条件查询对象总记录数
     * @param: [criteria]
     */
    Integer selectCountByCriteria(SystemSettingsCriteria criteria);

    // endregion

    Optional<SystemSettings> findById(String id);

    SystemSettings save(SystemSettings entity);
}
